Subject: Re: [PATCH WIP RFC 0/3] mpls: support for ler

From: roopa <[email-masked]>
Date: Fri, 12 Jun 2015 09:15:53 -0700

On 6/10/15, 12:13 AM, roopa wrote:
> Robert/Thomas, All my changes are in the below repo under the 'mpls' 
> branch.
> https://github.com/CumulusNetworks/net-next
> https://github.com/CumulusNetworks/iproute2
>
> The last iproute2 commit has a sample usage.
>
> The commits pushed to this tree do not contain support for the 
> following yet (but working on it):
> a) tunnel routes to work with tunnel RTA_OIF and a non-tunnel RTA_OIF:
> The current commits in the tree assume a non-tunnel RTA_OIF.
> If the tunnel driver has registered a dst_output func,  dst_output
> is set to the tunnel dst output handler in the receive route lookup 
> path which in turn does the encap
> and xmits. Thomas had last suggested using a flag to skip the dst 
> output handler re-direction
> for cases where RTA_OIF is a special tunnel netdev and the tunnel 
> driver xmit function
> can do the encap. My current thinking is to pass the oif to the encap 
> parse handler and the handler can set the flag on the tunnel state. 
> And this flag can then be used to skip the dst_output re-direction.
> This change should be trivial will fix it soon.

I have pushed this change to my github tree.
>
> b) make RTA_OIF optional and do a fib lookup.
>
thinking about this some more, RTA_OIF is already optional. And 
net/ipv4/fib_semantics.c:fib_check_nh will lookup the dev if not 
specified. Wouldn't that be enough ?. (unless i have misunderstood 
something here)

thanks,
Roopa